UNIT MATCH;
{
 * a rudimentary file name matching unit;
 * kept separate so that it can be improved/extended without affecting
 * the other sources;
 ** if anybody improves this unit, please let me have a copy!

     Dr Abimbola A Olowofoyeku (The African Chief);
     Email:  laa12@keele.ac.uk
     http://ourworld.compuserve.com/homepages/African_Chief/

 * TMT Pascal port by Vadim Bodrov, TMT Development Corporation
     Homepage: http://www.tmt.com
}

INTERFACE

FUNCTION Matches ( FileSpec : String; TheFName : string ) : Boolean;
{ does filename:TheFName match the file specification:FileSpec? }

IMPLEMENTATION

{$ifdef Win32}
{$ifndef __TMT__}
USES SysUtils;
{$else}
USES Strings;
{$endif}
{$else Win32}
FUNCTION ExtractFileName ( CONST aName : String ) : String;
{return the filename only - strip path out}
VAR
i : Word;
BEGIN
   FOR i := Length ( aName ) DOWNTO 1 DO
       IF aName [ i ] in [ ':', '\' ] THEN BEGIN
          ExtractFileName := Copy ( aName, i + 1, Length ( aName ) );
          Exit;
       END;
   ExtractFileName := aName;
END; { ExtractFileName }
FUNCTION UpperCase ( aName : string ) : string;
VAR
i : Word;
BEGIN
   FOR i := 1 TO length ( aName ) DO aName [ i ] := upcase ( aName [ i ] );
   UpperCase := aName;
END; { UpperCase }

{$endif Win32}

FUNCTION LastExtension ( CONST FName : string ) : string;
{ return just the extension }
VAR i, j : word;
BEGIN
   LastExtension := '';
   j := length ( FName );
   FOR i := j DOWNTO 1 DO IF FName [ i ] = '.' THEN Break;
   IF i < 2 THEN exit;
   LastExtension := copy ( FName, succ ( i ), j - i );
END; { LastExtension }
{****************************************************}
FUNCTION StripExtension ( CONST FName : string ) : string;
{ return just the name }
VAR i : word;
BEGIN
   StripExtension := FName;
   FOR i :=  length ( FName ) DOWNTO 1 DO IF FName [ i ] = '.' THEN Break;
   IF i < 2 THEN exit;
   StripExtension := copy ( FName, 1, pred ( i ) );
END; { StripExtension }
{****************************************************}
FUNCTION Matches ( FileSpec : String; TheFName : string ) : Boolean;
{
 rudimentary matching function;
 accepts only '', '*.*', 'XXX.*', '*.XXX', '*.XX?', 'XXX.YYY'

Parameters:
  FileSpec = the file specification to match
  TheFName = the file name to be checked for match against filespec
}
VAR
b,b1 : boolean;
i, j : word;
BEGIN
   Matches := TRUE;
   IF ( FileSpec = '*.*' ) OR ( FileSpec = '' ) THEN exit; {'' or '*.*' = all files match}

   i := length ( FileSpec );
   b1 := FALSE;
   if FileSpec [ i ] = '?' THEN BEGIN {e.g., *.PA?}
      FileSpec [ i ] := '*'; {replace '?' with '*'}
      b1 := TRUE;
   END;

   TheFName := UpperCase ( ExtractFileName ( TheFName ) );
   FileSpec := UpperCase ( FileSpec );

   b := copy ( FileSpec, 1, 2 ) = '*.';  {e.g., *.PAS}
   IF b THEN BEGIN
      If b1 then FileSpec [ i ] := TheFName [ Length ( TheFName ) ];
      delete ( FileSpec, 1, 2 );
      Matches := FileSpec = LastExtension ( TheFName );
   END ELSE BEGIN
      b := ( FileSpec [ i ] = '*' ) AND ( FileSpec [ pred ( i ) ] = '.' ); {e.g. TEST.*}
      IF b THEN BEGIN
         delete ( FileSpec, i, 1 );  {remove "*"}
         i := length ( FileSpec );
         IF FileSpec [ pred ( i ) ] = '*' {e.g. TEST*.*}
         THEN BEGIN
            delete ( FileSpec, pred ( i ), 2 );      {remove last dot}
            i := length ( FileSpec );
            Matches  := FileSpec = Copy ( StripExtension ( ( TheFName ) ), 1, i );
         END
         ELSE {e.g., TEST.*}
         BEGIN
            j := pos ( '.', TheFName );
            IF j = 0 THEN j := length ( TheFName );  {no extension: use the length}
            Matches := Copy ( FileSpec, 1, i ) = Copy ( TheFName, 1, j );
         END;
      END ELSE Matches := FileSpec = TheFName;
   END;
END;  { Matches }
{****************************************************}

END.
